﻿/*RecroGrid Framework DB v1.4.2 Core SQl Server*/

SET ANSI_NULLS ON
SET QUOTED_IDENTIFIER ON
SET ANSI_PADDING ON
GO

/*************************************************************************************************************************************************************************************/
/* ASP.NET Identity */
IF NOT EXISTS (SELECT * FROM sys.schemas WHERE name = N'RecroGrid')
EXEC sys.sp_executesql N'CREATE SCHEMA [RecroGrid]'
GO

IF EXISTS (SELECT * FROM INFORMATION_SCHEMA.TABLES WHERE TABLE_TYPE = 'BASE TABLE' and TABLE_NAME = 'vRecroSec_UsersInRole' AND TABLE_SCHEMA = 'RecroGrid')
	DROP TABLE [RecroGrid].[vRecroSec_UsersInRole]
GO
IF EXISTS (SELECT * FROM INFORMATION_SCHEMA.TABLES WHERE TABLE_TYPE = 'BASE TABLE' and TABLE_NAME = 'vRecroSec_User' AND TABLE_SCHEMA = 'RecroGrid')
	DROP TABLE [RecroGrid].[vRecroSec_User]
GO
IF EXISTS (SELECT * FROM INFORMATION_SCHEMA.TABLES WHERE TABLE_TYPE = 'BASE TABLE' and TABLE_NAME = 'vRecroSec_Role' AND TABLE_SCHEMA = 'RecroGrid')
	DROP TABLE [RecroGrid].[vRecroSec_Role]
GO

IF NOT EXISTS (SELECT * FROM sys.views WHERE object_id = OBJECT_ID(N'[RecroGrid].[vRecroSec_User]'))
BEGIN
DECLARE @statement nvarchar(4000)
IF EXISTS (SELECT * FROM INFORMATION_SCHEMA.TABLES WHERE TABLE_TYPE = 'BASE TABLE' and TABLE_NAME = 'AspNetUsers')
	SET @statement = N'CREATE VIEW [RecroGrid].[vRecroSec_User]
	AS SELECT Id AS UserId, UserName FROM AspNetUsers' 
ELSE
	SET @statement = N'CREATE VIEW [RecroGrid].[vRecroSec_User]
	AS SELECT null AS UserId, null as UserName WHERE 1=2' 

EXEC dbo.sp_executesql @statement
END
GO

IF NOT EXISTS (SELECT * FROM sys.views WHERE object_id = OBJECT_ID(N'[RecroGrid].[vRecroSec_Role]'))
BEGIN
DECLARE @statement nvarchar(4000)
IF EXISTS (SELECT * FROM INFORMATION_SCHEMA.TABLES WHERE TABLE_TYPE = 'BASE TABLE' and TABLE_NAME = 'AspNetRoles')
	SET @statement = N'CREATE VIEW [RecroGrid].[vRecroSec_Role]
	AS SELECT Id AS RoleId, Name as RoleName FROM AspNetRoles'
ELSE
	SET @statement = N'CREATE VIEW [RecroGrid].[vRecroSec_Role]
	AS SELECT null AS RoleId, null as RoleName WHERE 1=2' 

EXEC dbo.sp_executesql @statement
END
GO

IF NOT EXISTS (SELECT * FROM sys.views WHERE object_id = OBJECT_ID(N'[RecroGrid].[vRecroSec_UsersInRole]'))
BEGIN
DECLARE @statement nvarchar(4000)
IF EXISTS (SELECT * FROM INFORMATION_SCHEMA.TABLES WHERE TABLE_TYPE = 'BASE TABLE' and TABLE_NAME = 'AspNetUserRoles')
	SET @statement = N'CREATE VIEW [RecroGrid].[vRecroSec_UsersInRole]
	AS SELECT UserId, RoleId FROM AspNetUserRoles' 
ELSE
	SET @statement = N'CREATE VIEW [RecroGrid].[vRecroSec_UsersInRole]
	AS SELECT null AS UserId, null as RoleId WHERE 1=2' 

EXEC dbo.sp_executesql @statement
END
GO

IF EXISTS (SELECT * FROM INFORMATION_SCHEMA.TABLES WHERE TABLE_TYPE = 'BASE TABLE' and TABLE_NAME = 'AspNetRoles')
BEGIN
	EXEC dbo.sp_executesql @statement = 
	N'IF NOT EXISTS(SELECT * FROM [dbo].[AspNetRoles])
	BEGIN
		INSERT INTO [dbo].[AspNetRoles]([Id],[Name]) VALUES(1,''Administrators'')
		INSERT INTO [dbo].[AspNetRoles]([Id],[Name]) VALUES(2,''Users'')
	END'
END
GO

/*************************************************************************************************************************************************************************************/
IF EXISTS (SELECT * FROM sys.triggers WHERE object_id = OBJECT_ID(N'[RecroGrid].[RecroDict_Str_Change]'))
	EXEC dbo.sp_executesql @statement = N'DROP TRIGGER [RecroGrid].[RecroDict_Str_Change]'
EXEC dbo.sp_executesql @statement = N'CREATE TRIGGER [RecroGrid].[RecroDict_Str_Change] ON [RecroGrid].[RecroDict_Str]
   AFTER INSERT,DELETE,UPDATE
AS 
BEGIN
	-- SET NOCOUNT ON added to prevent extra result sets from
	-- interfering with SELECT statements.
	SET NOCOUNT ON;
    UPDATE [RecroGrid].[RecroGrid_Framework] SET ConfigValue = convert(varchar(128),getdate(),121) where ConfigName=''RecroDictLastUpdated''
END'
GO

IF EXISTS (SELECT * FROM sys.triggers WHERE object_id = OBJECT_ID(N'[RecroGrid].[RecroGrid_Entity_Change]'))
	EXEC dbo.sp_executesql @statement = N'DROP TRIGGER [RecroGrid].[RecroGrid_Entity_Change]'
EXEC dbo.sp_executesql @statement = N'CREATE TRIGGER [RecroGrid].[RecroGrid_Entity_Change] ON [RecroGrid].[RecroGrid_Entity]
   AFTER INSERT,DELETE,UPDATE
AS 
BEGIN
	SET NOCOUNT ON;
    UPDATE [RecroGrid].[RecroGrid_Framework] SET ConfigValue = convert(varchar(128),getdate(),121) where ConfigName=''TSContextLastUpdated''
END'
GO
IF EXISTS (SELECT * FROM sys.triggers WHERE object_id = OBJECT_ID(N'[RecroGrid].[RecroGrid_Property_Change]'))
	EXEC dbo.sp_executesql @statement = N'DROP TRIGGER [RecroGrid].[RecroGrid_Property_Change]'
EXEC dbo.sp_executesql @statement = N'CREATE TRIGGER [RecroGrid].[RecroGrid_Property_Change] ON [RecroGrid].[RecroGrid_Property]
   AFTER INSERT,DELETE,UPDATE
AS 
BEGIN
	SET NOCOUNT ON;
    UPDATE [RecroGrid].[RecroGrid_Framework] SET ConfigValue = convert(varchar(128),getdate(),121) where ConfigName=''TSContextLastUpdated''
END'
GO
IF EXISTS (SELECT * FROM sys.triggers WHERE object_id = OBJECT_ID(N'[RecroGrid].[RecroGrid_Options_Change]'))
	EXEC dbo.sp_executesql @statement = N'DROP TRIGGER [RecroGrid].[RecroGrid_Options_Change]'
EXEC dbo.sp_executesql @statement = N'CREATE TRIGGER [RecroGrid].[RecroGrid_Options_Change] ON [RecroGrid].[RecroGrid_Options]
   AFTER INSERT,DELETE,UPDATE
AS 
BEGIN
	SET NOCOUNT ON;
    UPDATE [RecroGrid].[RecroGrid_Framework] SET ConfigValue = convert(varchar(128),getdate(),121) where ConfigName=''TSContextLastUpdated''
END'
GO
IF EXISTS (SELECT * FROM sys.triggers WHERE object_id = OBJECT_ID(N'[RecroGrid].[RecroTrack_Table_Change]'))
	EXEC dbo.sp_executesql @statement = N'DROP TRIGGER [RecroGrid].[RecroTrack_Table_Change]'
EXEC dbo.sp_executesql @statement = N'CREATE TRIGGER [RecroGrid].[RecroTrack_Table_Change] ON [RecroGrid].[RecroTrack_Table]
   AFTER INSERT,DELETE,UPDATE
AS 
BEGIN
	SET NOCOUNT ON;
    UPDATE [RecroGrid].[RecroGrid_Framework] SET ConfigValue = convert(varchar(128),getdate(),121) where ConfigName=''TSContextLastUpdated''
END'
GO

IF EXISTS (SELECT * FROM sys.triggers WHERE object_id = OBJECT_ID(N'[RecroGrid].[RGFMenu_Change]'))
	EXEC dbo.sp_executesql @statement = N'DROP TRIGGER [RecroGrid].[RGFMenu_Change]'
EXEC dbo.sp_executesql @statement = N'CREATE TRIGGER [RecroGrid].[RGFMenu_Change] ON [RecroGrid].[RecroGrid_Menu]
   AFTER INSERT,DELETE,UPDATE
AS 
BEGIN
	SET NOCOUNT ON;
    UPDATE [RecroGrid].[RecroGrid_Framework] SET ConfigValue = convert(varchar(128),getdate(),121) where ConfigName=''RGFMenuLastUpdated''
END'
GO

IF EXISTS (SELECT * FROM sys.triggers WHERE object_id = OBJECT_ID(N'[RecroGrid].[DelEntity]'))
	EXEC dbo.sp_executesql @statement = N'DROP TRIGGER [RecroGrid].[DelEntity]'
EXEC dbo.sp_executesql @statement = N'CREATE TRIGGER [RecroGrid].[DelEntity] ON [RecroGrid].[RecroGrid_Entity]
INSTEAD OF DELETE
AS
BEGIN
	DELETE T FROM DELETED D INNER JOIN [RecroGrid].[RecroGrid_Options] T ON D.EntityId = T.EntityId
	DELETE T FROM DELETED D INNER JOIN [RecroGrid].[RecroGrid_Property] T ON D.EntityId = T.EntityBase
	DELETE T FROM DELETED D INNER JOIN [RecroGrid].[RecroGrid_Entity] T ON T.EntityId = D.EntityId
END' 
GO

/*************************************************************************************************************************************************************************************/
IF NOT EXISTS (SELECT * FROM sys.objects WHERE object_id = OBJECT_ID(N'[RecroGrid].[RecroGrid_ReplaceId]') AND type in (N'P', N'PC'))
	EXEC dbo.sp_executesql @statement = N'CREATE PROCEDURE [RecroGrid].[RecroGrid_ReplaceId] AS' 
GO
ALTER PROCEDURE [RecroGrid].[RecroGrid_ReplaceId]
    @OrigEntityId int,
    @NewEntityId int
AS
BEGIN
	begin try
		begin transaction
		SET IDENTITY_INSERT [RecroGrid].[RecroGrid_Entity] ON
		insert into [RecroGrid].[RecroGrid_Entity]
			   (EntityId
			   ,EntityName
			   ,EntityVersion
			   ,TypeDefinition
			   ,Category
			   ,Title
			   ,EntityComment)
			select 
				@NewEntityId
				,'_' + EntityName
				,EntityVersion
				,TypeDefinition
				,Category
				,Title
				,EntityComment from [RecroGrid].[RecroGrid_Entity] where EntityId=@OrigEntityId
		SET IDENTITY_INSERT [RecroGrid].[RecroGrid_Entity] OFF

		update [RecroGrid].RecroGrid_Property set EntityId=@NewEntityId where EntityId=@OrigEntityId
		update [RecroGrid].RecroGrid_Property set EntityBase=@NewEntityId where EntityBase=@OrigEntityId
		update [RecroGrid].RecroGrid_Options set EntityId=@NewEntityId where EntityId=@OrigEntityId

		delete from [RecroGrid].[RecroGrid_Entity] where EntityId=@OrigEntityId
		update [RecroGrid].[RecroGrid_Entity] set EntityName=SUBSTRING(EntityName,2,LEN(EntityName)-1) where EntityId=@NewEntityId
		commit
	end try
	begin catch
		rollback
	end catch
END
GO

/*************************************************************************************************************************************************************************************/
--FEP
IF EXISTS (SELECT * FROM INFORMATION_SCHEMA.TABLES WHERE TABLE_TYPE = 'BASE TABLE' and TABLE_NAME = 'vRecroSec_FEP')
	DROP TABLE [vRecroSec_FEP]
GO
IF EXISTS (SELECT * FROM sys.views WHERE object_id = OBJECT_ID(N'[vRecroSec_FEP]'))
	DROP VIEW [vRecroSec_FEP]
GO
CREATE VIEW [vRecroSec_FEP]
AS
	SELECT f.FEPId, EntityId, FEPType, TransactionId, Key1
	FROM RecroGrid.RecroSec_FEP f inner join (
		SELECT MAX(FEPId) as FEPId, Key1
		FROM RecroGrid.RecroTrack_Track rtt 
			inner join RecroGrid.RecroTrack_Object rto ON rtt.ObjectId = rto.ObjectId
			inner join RecroGrid.RecroSec_FEP fep ON rtt.TransactionId = fep.TransactionId
		GROUP BY Key1) t on f.FEPId = t.FEPId
GO

--RecroSec
IF EXISTS (SELECT * FROM INFORMATION_SCHEMA.TABLES WHERE TABLE_TYPE = 'BASE TABLE' and TABLE_NAME = 'vRecroSec')
	DROP TABLE [vRecroSec]
GO
IF EXISTS (SELECT * FROM sys.views WHERE object_id = OBJECT_ID(N'[RecroGrid].[vRecroSec]'))--RGF v1.0
	DROP VIEW [RecroGrid].[vRecroSec]
GO
IF EXISTS (SELECT * FROM sys.views WHERE object_id = OBJECT_ID(N'[vRecroSec]'))
	DROP VIEW [vRecroSec]
GO
CREATE VIEW [vRecroSec]
AS
	SELECT ObjectPermissionId, ObjectName, ObjectKey FROM [RecroGrid].RecroSec_ObjectPermission
GO

IF EXISTS (SELECT * FROM INFORMATION_SCHEMA.TABLES WHERE TABLE_TYPE = 'BASE TABLE' and TABLE_NAME = 'vRecroSec_BasePermission' AND TABLE_SCHEMA = 'RecroGrid')
	DROP TABLE [RecroGrid].[vRecroSec_BasePermission]
GO
IF EXISTS (SELECT * FROM sys.views WHERE object_id = OBJECT_ID(N'[RecroGrid].[vRecroSec_BasePermission]'))
	DROP VIEW [RecroGrid].[vRecroSec_BasePermission]
GO
CREATE VIEW [RecroGrid].[vRecroSec_BasePermission]
AS
	SELECT PermissionGroupId, CAST([CreatePerm] AS bit) AS [CreatePerm], CAST([ReadPerm] AS bit) AS [ReadPerm], CAST([UpdatePerm] AS bit) AS [UpdatePerm], CAST([DeletePerm] AS bit) AS [DeletePerm], getdate() AS [rowtimestamp]
	FROM (SELECT PermissionGroupId, MAX(CAST(CASE WHEN PermissionId = 1 THEN Permission ELSE NULL END AS int)) AS [CreatePerm], 
                MAX(CAST(CASE WHEN PermissionId = 2 THEN Permission ELSE NULL END AS int)) AS [ReadPerm], 
                MAX(CAST(CASE WHEN PermissionId = 4 THEN Permission ELSE NULL END AS int)) AS [UpdatePerm], 
                MAX(CAST(CASE WHEN PermissionId = 8 THEN Permission ELSE NULL END AS int)) AS [DeletePerm]
          FROM [RecroGrid].[RecroSec_Permission]
          GROUP BY PermissionGroupId) AS base
	WHERE ([CreatePerm] IS NOT NULL) OR
        ([ReadPerm] IS NOT NULL) OR
        ([UpdatePerm] IS NOT NULL) OR
        ([DeletePerm] IS NOT NULL)
GO

IF EXISTS (SELECT * FROM sysobjects WHERE id = object_id(N'[RecroGrid].[fnRecroSec_GetObjectPermission]') )
	DROP FUNCTION [RecroGrid].[fnRecroSec_GetObjectPermission]
GO
CREATE FUNCTION [RecroGrid].[fnRecroSec_GetObjectPermission]
		(@ObjectName varchar(255)
		,@ObjectKey nvarchar(128))
		
RETURNS int
AS
BEGIN
	declare @ObjectPermissionId int = null
	declare @idx int = CHARINDEX( '/' , @ObjectName)
	if( @idx > 0 and ISNUMERIC(@ObjectKey) = 1 )
	begin
	
		select @ObjectPermissionId = ObjectPermissionId
			from [RecroGrid].[RecroSec_ObjectPermission]
			where ObjectName = @ObjectName and Parent = @ObjectKey

		if( @@ROWCOUNT <> 0 )
			return @ObjectPermissionId

		if( @ObjectKey is not null and cast(@ObjectKey as int) <> 0 )
			return cast(@ObjectKey as int)

		--parent keresés
		set @ObjectName = substring(@ObjectName, 1, @idx-1)
		return [RecroGrid].[fnRecroSec_GetObjectPermission](@ObjectName, '')
	end

	if( isnull(@ObjectKey,'') <> '' )
	begin
		select @ObjectPermissionId = ObjectPermissionId
			from [RecroGrid].[RecroSec_ObjectPermission] 
			where ObjectName = @ObjectName and ObjectKey = @ObjectKey

		if( @@ROWCOUNT <> 0 )
			return @ObjectPermissionId
	end

	select @ObjectPermissionId = ObjectPermissionId
		from [RecroGrid].[RecroSec_ObjectPermission]
		where ObjectName = @ObjectName and ObjectKey is null
					
	return @ObjectPermissionId
END
GO

IF NOT EXISTS (SELECT * FROM sys.objects WHERE object_id = OBJECT_ID(N'[RecroGrid].[RecroSec_IsObjectValid]') AND type in (N'P', N'PC'))
	EXEC dbo.sp_executesql @statement = N'CREATE PROCEDURE [RecroGrid].[RecroSec_IsObjectValid] AS' 
GO
ALTER PROCEDURE [RecroGrid].[RecroSec_IsObjectValid]
		(@Name varchar(max)
		,@Type varchar(2)
		,@Valid bit output)
AS
BEGIN

	set @Valid = 0;
	if( isnull(@Name, '') != '')
	begin
		DECLARE @Database sysname = ''
		DECLARE @Schema nvarchar(384) = ''
    
		DECLARE @idx int;
		set @idx = charindex('.', @Name)
		if( @idx != 0 )
		begin
			set @Schema = left(@Name, @idx-1)
			set @Name = right(@Name, len(@Name)- @idx)
			set @idx = charindex('.', @Name)
			if( @idx != 0 )
			begin
				set @Database = @Schema
				if( substring(@Database, 1, 1) ='[' )
				begin
					set @Database = right(@Database, len(@Database)- 1)
					if( substring(@Database, len(@Database), 1) =']' )
						set @Database = left(@Database, len(@Database)- 1)
				end
				if( not exists(select * from master.sys.databases d where d.name=@Database) )
					return
				
				set @Schema = left(@Name, @idx-1)
				set @Name = right(@Name, len(@Name)- @idx)
			end
			if( substring(@Schema, 1, 1) ='[' )
			begin
				set @Schema = right(@Schema, len(@Schema)- 1)
				if( substring(@Schema, len(@Schema), 1) =']' )
					set @Schema = left(@Schema, len(@Schema)- 1)
			end
		end

		if( substring(@Name, 1, 1) ='[' )
		begin
			set @Name = right(@Name, len(@Name)- 1)
			if( substring(@Name, len(@Name), 1) =']' )
				set @Name = left(@Name, len(@Name)- 1)
		end

		DECLARE @Stmt NVARCHAR(max) = N'set @Res = case when exists(select * from '
		DECLARE @Parameter_Definition NVARCHAR(max) = N'@Type varchar(2), @Name varchar(390), @Schema varchar(384), @Res bit output'

		if( @Database <> '' )
			SET @Stmt = @Stmt + quotename(@Database) + '.'
		SET @Stmt = @Stmt + 'sys.objects o inner join sys.schemas s on o.schema_id=s.schema_id
			where type=@Type and o.name=@Name'
		
		if( @Schema <> '' )
			SET @Stmt = @Stmt + ' and s.name=@Schema'
		
		SET @Stmt = @Stmt + ') then 1 else 0 end'
	
		EXECUTE sp_executesql @Stmt, @Parameter_Definition, @Type=@Type, @Name=@Name, @Schema=@Schema, @Res=@Valid OUTPUT
	end					
END
GO

IF NOT EXISTS (SELECT * FROM sys.objects WHERE object_id = OBJECT_ID(N'[RecroGrid].[RecroSec_GetObjectPermission]') AND type in (N'P', N'PC'))
	EXEC dbo.sp_executesql @statement = N'CREATE PROCEDURE [RecroGrid].[RecroSec_GetObjectPermission] AS' 
GO
ALTER PROCEDURE [RecroGrid].[RecroSec_GetObjectPermission]
		(@ObjectName varchar(255)
		,@ObjectKey nvarchar(128) = null
)
AS
BEGIN

	declare @ObjectPermissionId int = [RecroGrid].[fnRecroSec_GetObjectPermission](@ObjectName, @ObjectKey) 
	select * from [RecroGrid].[RecroSec_ObjectPermission] where ObjectPermissionId = @ObjectPermissionId

END
GO

IF NOT EXISTS (SELECT * FROM sys.objects WHERE object_id = OBJECT_ID(N'[RecroGrid].[RecroSec_GetPermissionForUserA]') AND type in (N'P', N'PC'))
	EXEC dbo.sp_executesql @statement = N'CREATE PROCEDURE [RecroGrid].[RecroSec_GetPermissionForUserA] AS' 
GO
ALTER PROCEDURE [RecroGrid].[RecroSec_GetPermissionForUserA]
		(@UserId nvarchar(128)
		,@ObjectPermissionId int = 0
		,@ObjectName varchar(255) = null
		,@ObjectKey nvarchar(128) = null
		,@Storable bit output
		,@Preprocessing varchar(255) output
		,@Postprocessing varchar(255) output
		,@ErrorCode int output
		,@Nested int = 0
		,@UserName varchar(255) = null
)
AS
BEGIN

--1. PreprocessingTSQL, módosíthatja a kiindulási ObjectPermissionId-t (fa felépítésű adatok eseten hasznos)
--2. CustomUserPermission összegyűjtése
--3. UserPermission összegyűjtése priority szerint
--4. RolePermission összegyűjtése priority szerint
--5. Inheritance eseten parent alapján az 1. ponttól
--6. PostprocessingTSQL a #Permission módosítására

	set @ErrorCode = 0

	if( isnull(@ObjectPermissionId,0) = 0 and @ObjectName is not null )
		set @ObjectPermissionId = [RecroGrid].[fnRecroSec_GetObjectPermission](@ObjectName, @ObjectKey) 

	if( isnull(@ObjectPermissionId,0) = 0 )
	begin
		set @ErrorCode = -1
		if(@Nested = 0 )
		begin
			set @Storable = 0
			set @Preprocessing = null
			set @Postprocessing = null

			select 0 as PermissionId, cast(0 as bit) as Permission
			select @ErrorCode as ErrorCode, @Storable as Storable, @Preprocessing as Preprocessing, @Postprocessing as Postprocessing
		end
		return
	end

	if( @Nested = 0 )
	begin
		if( @UserId is null )
			select @UserId = UserId from [RecroGrid].[vRecroSec_User] where UserName = @UserName

		set @Storable = 1
		set @Preprocessing = null
		set @Postprocessing = null

		create table #Permission(
			[PermissionId] int NOT NULL,
			[Permission] bit NOT NULL,
			PRIMARY KEY ([PermissionId]))

		create table #Skip([ObjectPermissionId] int NOT NULL)
	end

	declare @isObjectValid bit,
			@statement nvarchar(4000),
			@parameters nvarchar(4000),
			@storable1 bit

	declare @parent int = null,
			@inheritance bit = 0,
			@preprocessingTSQL varchar(255) = null,
			@postprocessingTSQL varchar(255) = null,
			@preprocessing1 varchar(255) = null,
			@postprocessing1 varchar(255) = null

	select @parent = Parent
			,@inheritance = Inheritance
			,@preprocessingTSQL = PreprocessingTSQL, @postprocessingTSQL = PostprocessingTSQL
			,@preprocessing1 = Preprocessing, @postprocessing1 = Postprocessing
	from [RecroGrid].[RecroSec_ObjectPermission]
	where ObjectPermissionId = @ObjectPermissionId

	--1. PreprocessingTSQL, módosíthatja a kiindulási ObjectPermissionId-t (fa felépítésű adatok eseten hasznos)
	if( isnull(@preprocessingTSQL,'') <> '')
	begin
		exec [RecroGrid].[RecroSec_IsObjectValid] @Name = @preprocessingTSQL, @Type = 'P', @Valid = @isObjectValid output
		if( @isObjectValid = 1)
		begin
			set @statement = N'EXEC ' + @preprocessingTSQL + ' @UserId, @ObjectName, @ObjectKey, @ObjectPermissionId output, @Storable output'
			set @parameters = N'
				@UserId nvarchar(128)
				,@ObjectName varchar(255)
				,@ObjectKey nvarchar(128) = null
				,@ObjectPermissionId int output
				,@Storable bit output'

			declare @origObjectPermissionId int = @ObjectPermissionId
			set @storable1 = 1
			exec sp_executesql @statement, @parameters,
					@UserId, @ObjectName, @ObjectKey, @ObjectPermissionId output, @storable1 output

			if( @storable1 = 0 )
				set @Storable = 0

			if( @origObjectPermissionId <> @ObjectPermissionId )
			begin
				if( not exists(select * from #Skip where ObjectPermissionId=@ObjectPermissionId) )
				begin
					exec [RecroGrid].[RecroSec_GetPermissionForUserA]
						@UserId = @UserId
						,@ObjectPermissionId = @ObjectPermissionId
						,@ObjectName = @ObjectName
						,@ObjectKey = @ObjectKey
						,@Storable = @storable1 output 
						,@Preprocessing = @preprocessing1 output
						,@Postprocessing = @postprocessing1 output
						,@ErrorCode = @ErrorCode output
						,@Nested = @Nested

					if( @storable1 = 0 )
						set @Storable = 0

					if( @Preprocessing is null and isnull(@preprocessing1,'') <> '' )
						set @Preprocessing = @preprocessing1

					if( @Postprocessing is null and isnull(@postprocessing1,'') <> '' )
						set @Postprocessing = @postprocessing1

					return
				end
				set @ObjectPermissionId = @origObjectPermissionId
			end
		end
	end

	insert into #Skip values(@ObjectPermissionId)

	if( @Preprocessing is null and isnull(@preprocessing1,'') <> '' )
		set @Preprocessing = @preprocessing1

	if( @Postprocessing is null and isnull(@postprocessing1,'') <> '' )
		set @Postprocessing = @postprocessing1

	--2. CustomUserPermission összegyűjtése
	insert #Permission(PermissionId, Permission)
		select PermissionId, Permission from [RecroGrid].[RecroSec_CustomUserPermission]
		where UserId = @UserId and ObjectPermissionId = @ObjectPermissionId and PermissionId not in(select PermissionId from #Permission)

	--3. UserPermission összegyűjtése priority szerint
	declare @permissionGroupId int,
			@inheritable bit
	declare userPermissionGroup cursor for
		select g.permissionGroupId,op.inheritable
		from [RecroGrid].[RecroSec_PermissionGroup] g inner join
			 [RecroGrid].[RecroSec_OPPG] op on op.PermissionGroupId=g.PermissionGroupId inner join
			 [RecroGrid].[RecroSec_UserPermission] u on u.PermissionGroupId=g.PermissionGroupId
		where UserId=@UserId and ObjectPermissionId=@ObjectPermissionId
		order by op.[Priority]
	open userPermissionGroup
	fetch next from userPermissionGroup INTO @permissionGroupId, @inheritable
	while @@FETCH_STATUS = 0  
	begin
		if(@Nested = 0 or @inheritable = 1)
			insert #Permission(PermissionId, Permission)
				select PermissionId, Permission from [RecroGrid].[RecroSec_Permission]
				where PermissionGroupId=@permissionGroupId and PermissionId not in(select PermissionId from #Permission)

		fetch next from userPermissionGroup INTO @permissionGroupId, @inheritable
	end
	close userPermissionGroup
	deallocate userPermissionGroup

	--4. RolePermission összegyűjtése Role priority, azon belül priority szerint
	declare rolePermissionGroup cursor for
		select g.permissionGroupId,op.inheritable
		from [RecroGrid].[RecroSec_PermissionGroup] g inner join
			 [RecroGrid].[RecroSec_OPPG] op on op.PermissionGroupId=g.PermissionGroupId inner join
			 [RecroGrid].[RecroSec_RolePermission] r on g.PermissionGroupId=r.PermissionGroupId inner join
			 [RecroGrid].[vRecroSec_UsersInRole] ur on r.RoleId=ur.RoleId left outer join
			 [RecroGrid].[RecroSec_RolePriority] rp on r.RoleId=rp.RoleId
		where UserId=@UserId and ObjectPermissionId=@ObjectPermissionId
		order by isnull(rp.[Priority],2147483647), op.[Priority]
	open rolePermissionGroup
	fetch next from rolePermissionGroup INTO @permissionGroupId, @inheritable
	while @@FETCH_STATUS = 0  
	begin
		if(@Nested = 0 or @inheritable = 1)
			insert #Permission(PermissionId, Permission)
				select PermissionId, Permission from [RecroGrid].[RecroSec_Permission]
				where PermissionGroupId=@permissionGroupId and PermissionId not in(select PermissionId from #Permission)

		fetch next from rolePermissionGroup INTO @permissionGroupId, @inheritable
	end
	close rolePermissionGroup
	deallocate rolePermissionGroup

	--5. Inheritance eseten parent alapján az 1. ponttól
	if( @inheritance = 1 and @parent is not null)
	begin
		set @storable1 = 1
		exec [RecroGrid].[RecroSec_GetPermissionForUserA]
				@UserId = @UserId
				,@ObjectPermissionId = @Parent
				,@ObjectName = @ObjectName
				,@ObjectKey = @ObjectKey
				,@Storable = @storable1 output 
				,@Preprocessing = @preprocessing1 output
				,@Postprocessing = @postprocessing1 output
				,@ErrorCode = @ErrorCode output
				,@Nested = 1

		if( @ErrorCode <> 0 )
			return

		if( @storable1 = 0 )
			set @Storable = 0

		if( @Preprocessing is null and isnull(@preprocessing1,'') <> '' )
			set @Preprocessing = @preprocessing1

		if( @Postprocessing is null and isnull(@postprocessing1,'') <> '' )
			set @Postprocessing = @postprocessing1
	end

	--6. PostprocessingTSQL a #Permission módosítására
	if( isnull(@postprocessingTSQL,'') <> '')
	begin
		exec [RecroGrid].[RecroSec_IsObjectValid] @Name = @postprocessingTSQL, @Type = 'P', @Valid = @isObjectValid output
		if( @isObjectValid = 1)
		begin
			set @statement = N'EXEC ' + @postprocessingTSQL + ' @UserId, @ObjectName, @ObjectKey, @Storable output'
			set @parameters = N'
				@UserId nvarchar(128)
				,@ObjectName varchar(255)
				,@ObjectKey nvarchar(128) = null
				,@Storable bit output'

			set @storable1 = 1
			exec sp_executesql @statement, @parameters,
					@UserId, @ObjectName, @ObjectKey, @storable1 output

			if( @storable1 = 0 )
				set @Storable = 0
		end
	end

	--res
	if(@Nested = 0 )
	begin
		if( exists(select * from #Permission) )
			select PermissionId, Permission from #Permission order by 1
		else
			select 0 as PermissionId, cast(0 as bit) as Permission

		select @ErrorCode as ErrorCode, @Storable as Storable, @Preprocessing as Preprocessing, @Postprocessing as Postprocessing
	end

END
GO

IF NOT EXISTS (SELECT * FROM sys.objects WHERE object_id = OBJECT_ID(N'[RecroGrid].[RecroSec_GetPermissionForUser]') AND type in (N'P', N'PC'))
	EXEC dbo.sp_executesql @statement = N'CREATE PROCEDURE [RecroGrid].[RecroSec_GetPermissionForUser] AS' 
GO
ALTER PROCEDURE [RecroGrid].[RecroSec_GetPermissionForUser]
		(@UserId nvarchar(128)
		,@ObjectPermissionId int = 0
		,@ObjectName varchar(255) = null
		,@ObjectKey nvarchar(128) = null
		,@UserName varchar(255) = null
)
AS
BEGIN

	declare
		@Storable bit,
		@Preprocessing varchar(255),
		@Postprocessing varchar(255),
		@ErrorCode int

		exec [RecroGrid].[RecroSec_GetPermissionForUserA]
				@UserId = @UserId
				,@ObjectPermissionId = @ObjectPermissionId
				,@ObjectName = @ObjectName
				,@ObjectKey = @ObjectKey
				,@Storable = @Storable output 
				,@Preprocessing = @Preprocessing output
				,@Postprocessing = @Postprocessing output
				,@ErrorCode = @ErrorCode output
				,@Nested = 0
				,@UserName = @UserName

END
GO
