using Microsoft.AspNetCore.Authorization;
using Microsoft.AspNetCore.Mvc;
using Recrovit.RecroGridFramework;
using Recrovit.RecroGridFramework.Security;
using System;
using System.Linq;

namespace $rootnamespace$.Areas.RGF
{
    //[Authorize(Roles = "Administrators")]
    //[Authorize]
    [Area("RGF")]
    [ResponseCache(Duration = 0, Location = ResponseCacheLocation.None, NoStore = true)]
    public class AdminController : Controller
    {
        public IActionResult Index(string name = null)
        {
            AdminModel model = null;
            try
            {
                model = new AdminModel();
                model.Theme = this.HttpContext.Request.Cookies["rgf_theme"] ?? "base";
                model.EntityType = name;
                model.Grid = RecroGrid.CreateRG(new RecroGridContext(this.HttpContext), !string.IsNullOrEmpty(model.EntityType) ? model.EntityType : model.RecroGridType);
            }
            catch (Exception ex)
            {
                ViewBag.Error = ex.Message;
            }
            return View(model);
        }

        [HttpPost]
        public IActionResult Index(AdminModel model)
        {
            model.Grid = RecroGrid.CreateRG(new RecroGridContext(this.HttpContext), !string.IsNullOrEmpty(model.EntityType) ? model.EntityType : model.RecroGridType);
            return View(model);
        }

        [HttpPost]
        public ContentResult SetLanguage(string name)
        {
            var prev = RecroDict.SetSessionLanguage(this.HttpContext, name);
            return new ContentResult() { Content = prev };
        }

        [HttpPost]
        public ContentResult SetTheme(string name)
        {
            this.HttpContext.Response.Cookies.Append("rgf_theme", name);
            return new ContentResult() { Content = this.HttpContext.Request.Cookies["rgf_theme"] };
        }

        public ActionResult InitDatabase()
        {
            var model = new AdminModel(true);
            return View("Index", model);
        }

        public ActionResult RecroSec()
        {
            AdminModel model = null;
            try
            {
                model = new AdminModel();
                if (!model.InitDatabase)
                {
                    model.RecroSecModel = new RecroSecGUI(new RecroGridContext(this.HttpContext));
                }
            }
            catch (Exception ex)
            {
                ViewBag.Error = ex.Message;
            }
            return View("Index", model);
        }

        public ActionResult MenuDesigner()
        {
            ViewBag.Title = "Menu Designer";
            var grid = Recrovit.RecroGridFramework.UI.MenuDesigner.CreateDesigner(new RecroGridContext(this.HttpContext));
            return View("RGFDefaultView", grid);
        }
    }
}
